<div class="container-fluid">

  <form [formGroup]="approvalRequestForm" *ngIf="!showConfirmation">
    <div class="card">
      <div class="card-header bg-info text-white">
        <span class="text-bold text-center">Bill Payment Approval Request</span>
      </div>
      <div class="card-body">
        <span class="d-block p-2 bg-primary text-white">
          <span class="text-bold">General Detail</span>
        </span>
        <!--        <span class="text-bold blue">Budget Detail</span>-->
        <hr>
        <div class="row">
          <div class="col-sm-3">
            <div class="form-group">
              <label>Date <span class="required">*</span></label><br>
              <p-calendar name="date"
                          [style]="{'width':'100%'}" [inputStyle]="{'width':'100%'}"
                          [minDate]="minDate"
                          [showIcon]="false"
                          formControlName="requestedDate"
                          [ngClass]="{ 'is-invalid': submitted && f.requestedDate.errors }"
                          required
              >
              </p-calendar>
              <div *ngIf="submitted && f.requestedDate.errors" class="invalid-feedback">
                <div *ngIf="f.requestedDate.errors.required">Requested date is required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-3">
            <div class="form-group">
              <label for="expType">Expenditure Type<span class="required">*</span></label>
              <select id="expType"
                      class="form-control"
                      formControlName="expenditureType"
                      [ngClass]="{ 'is-invalid': submitted && f.expenditureType.errors }"
                      name="expType"
                      required>
                <option *ngFor="let event of (expenditureTypes); let i = index"
                        [ngValue]="(expenditureTypes)[i]"
                >{{(expenditureTypes)[i].type + ' ( ' + (expenditureTypes)[i].value + ' )'}}</option>
              </select>
              <div *ngIf="submitted && f.expenditureType.errors" class="invalid-feedback">
                <div *ngIf="f.expenditureType.errors.required">Expenditure Type is Required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-3">
            <div class="form-group">
              <label for="month">Month<span class="required">*</span></label>
              <select id="month"
                      class="form-control"
                      name="expType"
                      formControlName="month"
                      [ngClass]="{ 'is-invalid': submitted && f.month.errors }"
                      required
              >
                <option *ngFor="let event of (months); let i = index"
                        [ngValue]="(months)[i]"
                >{{ (months)[i].months }}</option>
              </select>
              <div *ngIf="submitted && f.month.errors" class="invalid-feedback">
                <div *ngIf="f.month.errors.required">Month is Required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-3">
            <div class="form-group">
              <label for="fiscalYear">Fiscal Year<span class="required">*</span></label>
              <select id="fiscalYear"
                      class="form-control"
                      name="fiscalYear"
                      formControlName="fiscalYear"
                      [ngClass]="{ 'is-invalid': submitted && f.fiscalYear.errors }"
                      required
              >
                <option *ngFor="let event of (fiscalYears); let i = index"
                        [ngValue]="(fiscalYears)[i]"
                >{{ (fiscalYears)[i].year }}</option>
              </select>
              <div *ngIf="submitted && f.fiscalYear.errors" class="invalid-feedback">
                <div *ngIf="f.fiscalYear.errors.required">Fiscal Year is Required.</div>
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group">
              <label for="subject">Subject<span class="required">*</span></label>
              <input type="text"
                     class="form-control"
                     id="subject"
                     placeholder="Enter Subject"
                     formControlName="subject"
                     [ngClass]="{ 'is-invalid': submitted && f.subject.errors }"
                     required
              >
              <div *ngIf="submitted && f.subject.errors" class="invalid-feedback">
                <div *ngIf="f.subject.errors.required">Subject is Required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-6">
            <div class="form-group">
              <label for="link">Reference Link</label>
              <input type="text"
                     class="form-control"
                     id="link"
                     placeholder="For Multiple link Please use space after each link."
                     formControlName="link"
              >
            </div>
          </div>
        </div>
        <div class="form-group">
          <label for="expenseDetail">Expense Detail<span class="required">*</span></label>
          <ckeditor [editor]="Editor"
                    [ngClass]="{ 'is-invalid': submitted && f.expenseDetail.errors }"
                    id="expenseDetail"
                    name="expenseDetail"
                    tagName="textarea"
                    [editor]="Editor"
                    placeholder="Enter Description ( Max length 1000 )"
                    formControlName="expenseDetail"></ckeditor>
          <div *ngIf="submitted && f.expenseDetail.errors" class="invalid-feedback">
            <div *ngIf="f.expenseDetail.errors.required">Expense Detail is Required.</div>
          </div>
        </div>

        <span class="d-block p-2 bg-primary text-white">
          <span class="text-bold">Billing Detail</span>
        </span>
        <hr>
        <div class="row">
          <div class="col-sm-4">
            <div class="form-group">
              <label for="vendor">Vendor<span class="required">*</span></label>
              <select id="vendor"
                      class="form-control"
                      name="vendor"
                      formControlName="vendor"
                      (ngModelChange)="renderForm($event)"
                      [ngClass]="{ 'is-invalid': submitted && f.vendor.errors }"
                      required
              >
                <option *ngFor="let event of (vendors); let i = index"
                        [ngValue]="(vendors)[i]"
                >{{ (vendors)[i].name + ' ( ' + (vendors)[i].accountNumber + ' )' }}</option>
              </select>
              <div *ngIf="submitted && f.vendor.errors" class="invalid-feedback">
                <div *ngIf="f.vendor.errors.required">Vendor is Required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label>Bill Date<span class="required">*</span></label><br>
              <p-calendar name="date"
                          [style]="{'width':'100%'}" [inputStyle]="{'width':'100%'}"
                          [minDate]="minDate"
                          size="20"
                          [showIcon]="false"
                          formControlName="billingDate"
                          [ngClass]="{ 'is-invalid': submitted && f.billingDate.errors }"
                          required
              >
                <div *ngIf="submitted && f.billingDate.errors" class="invalid-feedback">
                  <div *ngIf="f.billingDate.errors.required">Billing is Required.</div>
                </div>
              </p-calendar>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="billAmount">Bill Amount<span class="required">*</span></label>
              <input type="number"
                     class="form-control"
                     id="billAmount"
                     placeholder="Bill Amount"
                     formControlName="billAmount"
                     [ngClass]="{ 'is-invalid': submitted && f.billAmount.errors }"
                     required
              >
              <div *ngIf="submitted && f.billAmount.errors" class="invalid-feedback">
                <div *ngIf="f.billAmount.errors.required">Bill Amount is Required.</div>
              </div>
              <span *ngIf="approvalRequestForm.value.billAmount" style="color: green">
                      {{approvalRequestForm.value.billAmount | numberToWords}}
                    </span>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="billNumber">Bill Number<span class="required">*</span></label>
              <input type="number"
                     class="form-control"
                     id="billNumber"
                     placeholder="Bill Number"
                     formControlName="billNumber"
                     [ngClass]="{ 'is-invalid': submitted && f.billNumber.errors }"
                     required
              >
              <div *ngIf="submitted && f.billNumber.errors" class="invalid-feedback">
                <div *ngIf="f.billNumber.errors.required">Bill Number Required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="advanceTaken">Advance Taken</label>
              <input type="number"
                     class="form-control"
                     id="advanceTaken"
                     placeholder="Advance Taken"
                     formControlName="advance"
              >
              <span *ngIf="approvalRequestForm.value.advance" style="color: green">
                      {{approvalRequestForm.value.advance | numberToWords}}
                    </span>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="regType">Registration Type<span class="required">*</span></label>
              <select id="regType"
                      class="form-control"
                      formControlName="registrationType"
                      [ngClass]="{ 'is-invalid': submitted && f.registrationType.errors }"
                      name="expType"
                      required
              >
                <option *ngFor="let event of (registrationTypes); let i = index"
                        [ngValue]="(registrationTypes)[i]"
                >{{ (registrationTypes)[i] }}</option>
              </select>
              <div *ngIf="submitted && f.registrationType.errors" class="invalid-feedback">
                <div *ngIf="f.registrationType.errors.required">Registration Type is Required.</div>
              </div>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="regNumber">Reg. Number</label>
              <input type="text"
                     class="form-control"
                     id="regNumber"
                     placeholder="Reg. Number"
                     formControlName="registrationNumber"
              >
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="vendorAccountNumber">Vendor A/C Number</label>
              <input type="text"
                     class="form-control"
                     id="vendorAccountNumber"
                     placeholder="Vendor Account Number"
                     formControlName="vendorAccountNumber"
              >
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="penaltyAmount">Penalty Amount</label>
              <input type="number"
                     class="form-control"
                     id="penaltyAmount"
                     name="penaltyAmount"
                     placeholder="TDS Amount"
                     formControlName="penaltyAmount"
              >
              <!--              <p-inputNumber formControlName="penaltyAmount"-->
              <!--                             [size]="23"-->
              <!--                             id="penaltyAmount"-->
              <!--                             mode="decimal"-->
              <!--                             [minFractionDigits]="2"></p-inputNumber>-->
              <span *ngIf="approvalRequestForm.value.penaltyAmount" style="color: green">
                      {{approvalRequestForm.value.penaltyAmount | numberToWords}}
              </span>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="rebateAmount">Rebate Amount</label>
              <input type="number"
                     class="form-control"
                     id="rebateAmount"
                     placeholder="TDS Amount"
                     formControlName="rebateAmount"
              >
              <span *ngIf="approvalRequestForm.value.rebateAmount" style="color: green">
                      {{approvalRequestForm.value.rebateAmount | numberToWords}}
                    </span>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="customFile">Choose file<span class="required">*</span></label>
              <input type="file"
                     formControlName="file"
                     [ngClass]="{ 'is-invalid': submitted && f.billNumber.errors }"
                     class="form-control"
                     id="customFile"
                     multiple
                     (change)="onFileChange($event)"
                     required
              >
              <div *ngIf="submitted && f.file.errors" class="invalid-feedback">
                <div *ngIf="f.file.errors.required">File is Required.</div>
              </div>
              <span style="color: red" *ngIf="showFileValidationMessage">Unsupported file format.</span>
            </div>
          </div>
        </div>
      </div>

      <hr>
      <div class="card-body">
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group">
              <label for="supporter">Select Supporter</label><br>
              <p-autoComplete formControlName="supporters"
                              [ngClass]="{ 'is-invalid': submitted && f.supporters.errors }"
                              id="supporter"
                              class="ui-fluid"
                              [inputStyle]="{'width':'180px'}"
                              [suggestions]="supporter"
                              (completeMethod)="searchSupporter($event)"
                              [minLength]="5"
                              field="fullName"
                              [scrollHeight]="200"
                              placeholder="Enter Name or Employee Id"
                              [multiple]="true">
                <ng-template let-value pTemplate="selectedItem">
                  <span style="font-size:18px">{{value.fullName + '( ' + value.designation + ') '}}</span>
                </ng-template>
              </p-autoComplete>
            </div>
          </div>
          <div class="col-sm-6">
            <div class="form-group">
              <label for="approver">Select Approver<span class="required">*</span></label><br>
              <p-autoComplete formControlName="approvers"
                              [ngClass]="{ 'is-invalid': submitted && f.approvers.errors }"
                              id="approver"
                              class="ui-fluid"
                              [inputStyle]="{'width':'180px'}"
                              [suggestions]="approver"
                              (completeMethod)="searchApprover($event)"
                              [minLength]="5"
                              field="fullName"
                              [scrollHeight]="200"
                              placeholder="Enter Name or Employee Id"
                              [multiple]="true">
                <ng-template let-value pTemplate="selectedItem">
                  <span style="font-size:18px">{{value.fullName + '( ' + value.designation + ') '}}</span>
                </ng-template>
              </p-autoComplete>
              <div *ngIf="submitted && f.approvers.errors" class="invalid-feedback">
                <div *ngIf="f.approvers.errors.required">Approver is Required.</div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="card-body">
        <span *ngIf="showAmountMismatchMessage" style="color: red;"> Total proposed expenses amount is not equal to bill amount.
          Please, verify. </span>
        <table class="table table-bordered" formArrayName="transactionDetailRequest">
          <tr>
            <th colspan="6">Proposed Expenses:</th>
            <th style="width: 5%">
              <button type="button"
                      (click)="addTransactionDetail()"
                      class="btn btn-primary btn-xs">
                <i class="pi pi-plus-circle"></i>
              </button>
            </th>
          </tr>
          <tr *ngFor="let expense of transactionDetailRequest().controls; let i=index" [formGroupName]="i">
            <td style="width: 0%" hidden="true">
              <input type="text" formControlName="expenditureTxnDetailId" class="form-control" hidden="true">
            </td>

            <td style="width: 15%">
              Debit Branch<span class="required">*</span>
              <select id="debitBranch"
                      class="form-control"
                      name="debitBranch"
                      formControlName="debitBranchId"
                      required>
                <option *ngFor="let event of (allBranch); let i = index"
                        [ngValue]="(allBranch)[i]"
                >{{(allBranch)[i].name + ' ( ' + (allBranch)[i].code + ' )'}}</option>
              </select>
            </td>

            <td style="width: 18%">
              Debit Account<span class="required">*</span>
              <span class="col-sm-2" *ngIf="this.approvalRequestForm.value.fiscalYear
              && this.approvalRequestForm.value.month
              && this.approvalRequestForm.value.transactionDetailRequest[i].debitBranchId
              && this.approvalRequestForm.value.transactionDetailRequest[i].accountHeadId">
                    <app-dynamic-dialog
                      [popupType]="'budget-detail'"
                      [fiscalYearId]="this.approvalRequestForm.value.fiscalYear.id"
                      [month]="this.approvalRequestForm.value.month.months"
                      [branchId]="this.approvalRequestForm.value.transactionDetailRequest[i].debitBranchId.branchId"
                      [accountHeadId]="this.approvalRequestForm.value.transactionDetailRequest[i].accountHeadId.accountHeadId"
                    ></app-dynamic-dialog>
                  </span>
              <select id="accountHead"
                      class="form-control"
                      formControlName="accountHeadId"
                      name="accountHead"
                      required
              >
                <option *ngFor="let event of (accountHeads); let i = index"
                        [ngValue]="(accountHeads)[i]"
                >{{(accountHeads)[i].description + ' ( ' + (accountHeads)[i].code + ' )'}}</option>
              </select>
            </td>

            <td style="width: 15%">
              Credit Branch<span class="required">*</span>
              <select id="creditBranch"
                      class="form-control"
                      name="creditBranch"
                      formControlName="creditBranchId"
                      required
              >
                <!--                <option selected="null">Select</option>-->
                <option *ngFor="let event of (allBranch); let i = index"
                        [ngValue]="(allBranch)[i]"
                >{{(allBranch)[i].name + ' ( ' + (allBranch)[i].code + ' )'}}</option>
              </select>
            </td>
            <td style="width: 15%">
              Cr Account<span class="required">*</span>
              &nbsp;
              <app-dynamic-dialog
                [popupType]="'account-detail'"
                [accountNumber]="this.approvalRequestForm.value.transactionDetailRequest[i].creditAccount"
              ></app-dynamic-dialog>
              <input type="text"
                     formControlName="creditAccount"
                     class="form-control"
                     maxlength="16"
                     minlength="12"
                     required>
              <span style="color: red; font-size: 9px">Min: 12; Max:16 Character</span>
            </td>

            <td style="width: 22%">
              Bill Amt<span class="required">*</span>
              <div class="row">
                <div class="col-sm-10">
                  <input type="number"
                         formControlName="billAmt"
                         class="form-control"
                         required>
                  <span *ngIf="this.approvalRequestForm.value.transactionDetailRequest[i].billAmt" style="color: green">
                      {{approvalRequestForm.value.transactionDetailRequest[i].billAmt | numberToWords}}
                  </span>
                </div>
                <div class="col-sm-2">
                  <a (click)="calculateTDSAmount(i)">
                    <svg width="2em"
                         height="2em"
                         viewBox="0 0 16 16"
                         class="bi bi-calculator"
                         fill="currentColor"
                         xmlns="http://www.w3.org/2000/svg">
                      <path fill-rule="evenodd"
                            d="M2 2a2 2 0 0 1 2-2h8a2 2 0 0 1 2 2v12a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V2zm2 .5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-.5.5h-7a.5.5 0 0 1-.5-.5v-2zm0 4a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1zM4.5 9a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5h-1zM4 12.5a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1zM7.5 6a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5h-1zM7 9.5a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1zm.5 2.5a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5h-1zM10 6.5a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1zm.5 2.5a.5.5 0 0 0-.5.5v4a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-4a.5.5 0 0 0-.5-.5h-1z"/>
                    </svg>
                  </a>
                </div>
              </div>
              <div class="row" *ngIf="showTDSTotalAmount">
                <div class="col-sm-6">
                  Total <span class="required">*</span>
                  <p-inputNumber formControlName="amount"
                                 [size]="7"
                                 id="amount"
                                 mode="decimal"
                                 [minFractionDigits]="2"></p-inputNumber>
                </div>
                <div class="col-sm-6">
                  TDS <span class="required">*</span>
                  <p-inputNumber formControlName="tdsAmount"
                                 [size]="7"
                                 id="tdAmount"
                                 mode="decimal"
                                 [minFractionDigits]="2">
                  </p-inputNumber>
                </div>
              </div>
              <span style="font-size: 10px; color: red">
                Click on Calculator for TDS.
              </span>
            </td>
            <td style="width: 17%">
              Detail<span class="required">*</span>
              <textarea class="form-control"
                        rows="3"
                        formControlName="transactionDetail"
                        placeholder="Enter Transaction Detail (Min: 10 , Max 45 Characters)"
                        maxlength="45"
                        required
              >
              </textarea>
            </td>
            <td style="width: 5%">
              <button (click)="removeTransactionDetail(i)"
                      class="btn btn-danger btn-xs">
                <i class="pi pi-trash"></i>
              </button>
            </td>
          </tr>
        </table>
      </div>
    </div>
    <div class="card-footer">
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  type="submit"
                  (click)="confirmCreateRequest()">
            Submit
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block" (click)="resetForm()">Cancel</button>
        </div>
      </div>
    </div>
  </form>
</div>


<p-dialog [(visible)]="showConfirmationPage"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '790px', height: 'auto'}">
  <p-header>
    <h3 style="font-weight: 800;color: #454545;float: left; margin: 0;">
      Confirm, Bill Payment Request Detail</h3>
  </p-header>
  <div class="row">
    <div class="col-md-12 mt-3">
      <strong>Budget Detail</strong>
      <hr>
      <div class="col-md-6 form-group float-left">
        <label>Requested Date :</label>
        <p>{{ approvalRequestForm.value.requestedDate | date: 'short' }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="approvalRequestForm.value.expenditureType">
        <label>Expenditure Type :</label>
        <p>{{ approvalRequestForm.value.expenditureType.type }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="approvalRequestForm.value.month">
        <label>Months :</label>
        <p>{{ approvalRequestForm.value.month.months }}</p>
      </div>

      <div class="col-md-6 form-group float-left" *ngIf="approvalRequestForm.value.fiscalYear">
        <label>Fiscal Year :</label>
        <p>{{ approvalRequestForm.value.fiscalYear.year }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Subject:</label>
        <p>{{approvalRequestForm.value.subject}}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <strong>Bill Detail </strong>
      <hr>
      <div class="col-md-6 form-group float-left" *ngIf="approvalRequestForm.value.vendor">
        <label>Vendor Name :</label>
        <p>{{ approvalRequestForm.value.vendor.name }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Bill Date :</label>
        <p>{{ approvalRequestForm.value.billingDate | date: 'short' }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Bill Number :</label>
        <p>{{ approvalRequestForm.value.billNumber }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Bill Amount :</label>
        <p>{{approvalRequestForm.value.billAmount}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Advance Taken:</label>
        <p>{{approvalRequestForm.value.advance}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Reg. Type :</label>
        <p>{{approvalRequestForm.value.registrationType}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Reg. Number :</label>
        <p>{{ approvalRequestForm.value.registrationNumber }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>TDS Amount:</label>
        <p>{{approvalRequestForm.value.tdsAmount }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Acc. Number :</label>
        <p>{{ approvalRequestForm.value.vendorAccountNumber }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="approvalRequestForm.value.penaltyAmount > 0 ">
        <label>Penalty Amount :</label>
        <p>{{ approvalRequestForm.value.penaltyAmount }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="approvalRequestForm.value.rebateAmount > 0 ">
        <label>Rebate Amount :</label>
        <p>{{ approvalRequestForm.value.rebateAmount }}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <div class="col-md-6 form-group float-left">
        <label>Approved By:</label>
        <p *ngFor="let approvers of approvalRequestForm.value.approvers">
          {{approvers.fullName + ' ( ' + approvers.designation + ' )'}}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <div class="col-md-6 form-group float-left">
        <label>Supported By:</label>
        <p *ngFor="let supporters of approvalRequestForm.value.supporters">
          {{supporters.fullName + ' ( ' + supporters.designation + ' )'}}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3" *ngIf="approvalRequestForm.value.transactionDetailRequest">
      <table class="table">
        <thead>
        <tr>
          <th scope="col">Debit Branch</th>
          <th scope="col">Debit Acc.</th>
          <th scope="col">Credit Branch</th>
          <th scope="col">Credit Acc.</th>
          <th scope="col">Amount</th>
          <th scope="col">Detail</th>
        </tr>
        </thead>
        <tbody>
        <tr *ngFor="let expenses of  approvalRequestForm.value.transactionDetailRequest">
          <td>{{expenses.debitBranchId?.name}}</td>
          <td>{{expenses.accountHeadId?.description}}</td>
          <td>{{expenses.creditBranchId?.name}}</td>
          <td>{{expenses.creditAccount}}</td>
          <td>{{expenses.amount}}</td>
          <td>{{expenses.transactionDetail}}</td>
        </tr>
        </tbody>
      </table>
    </div>
  </div>
  <footer>
    <div class="row">
      <div class="col-md-12">
        <div class="col-md-12 mb-3">
          <button class="btn btn-sm btn-success float-right"
                  type="submit"
                  [disabled]="loading"
                  (click)="onSubmit()">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Confirm
          </button>
          <button class="btn btn-sm btn-danger btn-outline- ml-3 float-right"
                  type="button"
                  [disabled]="loading"
                  (click)="showConfirmationPage=false">
            Cancel
          </button>
        </div>
      </div>
    </div>
  </footer>
</p-dialog>


<p-dialog [(visible)]="showTdsCalculateForm"
          [modal]="true" [responsive]="true" [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '300px', height: 'auto'}">
  <p-header>
    <h3 style="font-weight: 800;color: #454545;float: left; margin: 0;">TDS Calculator</h3>
  </p-header>
  <form [formGroup]="tdsCalculatorForm">
    <div class="row">
      <div class="col-sm-6">
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="registrationType"
                 value="PAN"
                 id="registrationType1"
                 formControlName="registrationType">
          <label class="form-check-label" for="registrationType1">PAN</label>
        </div>
      </div>
      <div class="col-sm-6">
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="registrationType"
                 id="registrationType2"
                 value="VAT"
                 formControlName="registrationType">
          <label class="form-check-label" for="registrationType2">VAT</label>
        </div>
      </div>
    </div>
    <br>
    <div class="form-group">
      <label for="tdsPercentage">TDS ( % )</label>
      <div class="row">
        <div class="col-sm-3">
          <button class="btn btn-success btn-xs"
                  (click)="fillForm('1.5')"
                  style="width: 100%"> 1.5 %
          </button>
        </div>
        <div class="col-sm-3">
          <button class="btn btn-success btn-xs"
                  (click)="fillForm('5')"
                  style="width: 100%"> 5 %
          </button>
        </div>
        <div class="col-sm-3" *ngIf="this.tdsCalculatorForm.value.registrationType === 'VAT'">
          <button class="btn btn-success btn-xs"
                  (click)="fillForm('10')"
                  style="width: 100%"> 10 %
          </button>
        </div>
        <div class="col-sm-3">
          <button class="btn btn-success btn-xs"
                  (click)="fillForm('15')"
                  style="width: 100%"> 15 %
          </button>
        </div>
      </div>
      <br>
      <input type="number"
             class="form-control"
             id="tdsPercentage"
             formControlName="tdsPercentage"
             placeholder="Enter TDS Percentage (% )">
    </div>
  </form>
  <footer>
    <div class="row">
      <div class="col-sm-6">
        <button class="btn btn-sm btn-success btn-block"
                (click)="calculate()"
                type="submit">
          Submit
        </button>
      </div>
      <div class="col-sm-6">
        <button class="btn btn-sm btn-danger btn-block"
                (click)="resetTDSForm()"
                type="submit">
          Cancel
        </button>
      </div>
    </div>
  </footer>
</p-dialog>
